Tests: Fix first line of output to follow TAP guidelines
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
1 #!/bin/bash
2 #
3 # Copyright (C) - 2012 Christian Babeux <christian.babeux@efficios.com>
4 # David Goulet <dgoulet@efficios.com>
5 #
6 # This library is free software; you can redistribute it and/or modify it under
7 # the terms of the GNU Lesser General Public License as published by the Free
8 # Software Foundation; version 2.1 of the License.
9 #
10 # This library is distributed in the hope that it will be useful, but WITHOUT
11 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
12 # FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
13 # details.
14 #
15 # You should have received a copy of the GNU Lesser General Public License
16 # along with this library; if not, write to the Free Software Foundation, Inc.,
17 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
18
19 TEST_DESC="Streaming - High throughput with bandwidth limits"
20
21 CURDIR=$(dirname $0)/
22 TESTDIR=$CURDIR/../../..
23 NR_APP_ITER=10
24 NR_ITER=1000000
25 BIN_NAME="gen-ust-events"
26 SESSION_NAME="high-throughput"
27 EVENT_NAME="tp:tptest"
28 SESSIOND_CTRL_PORT=5342
29 SESSIOND_DATA_PORT=5343
30 DEFAULT_IF="lo"
31
32 TRACE_PATH=$(mktemp -d)
33
34 NUM_TESTS=112
35
36 source $TESTDIR/utils/utils.sh
37
38 if [ ! -x "$CURDIR/$BIN_NAME" ]; then
39 BAIL_OUT "No UST nevents binary detected."
40 fi
41
42 function set_bw_limit
43 {
44 limit=$1
45 ctrlportlimit=$(($limit/10))
46 # failsafe to have at least 1kbit/s for control (in the case where $1 < 10)
47 [ $ctrlportlimit = 0 ] && ctrlportlimit=1
48 # if $1 < 10, we might bust the limit set here, but the
49 # parent qdisc (1:) will always limit us to the right max value
50 dataportlimit=$((9*${ctrlportlimit}))
51
52
53 tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
54
55 # the total bandwidth is the limit set by the user
56 tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
57 # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
58 tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
59 # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
60 tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
61
62 # filter to assign control traffic to the 1:10 class
63 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
64 # filter to assign data traffic to the 1:11 class
65 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
66
67 ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
68 }
69
70 function reset_bw_limit
71 {
72 tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
73 ok $? "Reset bandwith limits"
74 }
75
76 function create_lttng_session_with_uri
77 {
78 sess_name=$1
79 uri=$2
80 # Create session with custom URI
81 $TESTDIR/../src/bin/lttng/$LTTNG_BIN create -U $uri $sess_name >/dev/null 2>&1
82 ok $? "Create session with uri $uri"
83 }
84
85 function run_apps
86 {
87 for i in `seq 1 $NR_APP_ITER`; do
88 # With bandwidth limitation, unfortunately, application easily timeout
89 # due to very slow communication between the consumer and relayd making
90 # the status reply from the consumer quite slow thus delaying the
91 # registration done message.
92 LTTNG_UST_REGISTER_TIMEOUT=-1 ./$CURDIR/$BIN_NAME $NR_ITER & >/dev/null 2>&1
93 done
94 }
95
96 function wait_apps
97 {
98 while [ -n "$(pidof $BIN_NAME)" ]; do
99 sleep 1
100 done
101 pass "Wait for applications to end"
102 }
103
104 function test_high_throughput
105 {
106 NETWORK_URI="net://localhost"
107 create_lttng_session_with_uri $SESSION_NAME $NETWORK_URI
108 enable_ust_lttng_event $SESSION_NAME $EVENT_NAME
109 start_lttng_tracing $SESSION_NAME
110 run_apps
111 wait_apps
112 stop_lttng_tracing $SESSION_NAME
113 destroy_lttng_session $SESSION_NAME
114 validate_event_count
115 }
116
117 function validate_event_count
118 {
119
120 TEMP_FILE=$(mktemp)
121 TEMP_FILE_2=$(mktemp)
122
123 traced=$(babeltrace $TRACE_PATH 2>/dev/null | wc -l)
124 babeltrace $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
125
126 cat $TEMP_FILE_2 | cut -f4 -d " " >$TEMP_FILE
127
128 dropped=0
129 while read line;
130 do
131 let dropped=$dropped+$line
132 done < $TEMP_FILE
133
134 let total=$dropped+$traced
135 let wanted=$NR_APP_ITER*$NR_ITER
136
137 if [ $wanted -ne $total ]; then
138 fail "Validate trace event count"
139 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
140 return 1
141 else
142 pass "Validate trace event count"
143 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
144
145 rm -rf $TRACE_PATH
146 rm $TEMP_FILE $TEMP_FILE_2
147
148 return 0
149 fi
150 }
151
152 function interrupt_cleanup()
153 {
154 diag "*** Exiting ***"
155 stop_lttng_relayd
156 stop_lttng_sessiond
157 reset_bw_limit
158 exit 1
159 }
160
161 plan_tests $NUM_TESTS
162
163 print_test_banner "$TEST_DESC"
164
165 if [ "$(id -u)" == "0" ]; then
166 isroot=1
167 else
168 isroot=0
169 fi
170
171 skip $isroot "Root access is needed to set bandwith limits. Skipping all tests." $NUM_TESTS ||
172 {
173
174 # Catch sigint and try to cleanup limits
175 trap interrupt_cleanup SIGINT
176
177 BW_LIMITS=(3200 1600 800 400 200 100 50 25)
178 for BW in ${BW_LIMITS[@]};
179 do
180 diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
181 set_bw_limit $BW
182
183 start_lttng_sessiond
184 start_lttng_relayd "-o $TRACE_PATH"
185 test_high_throughput
186 result=$?
187 stop_lttng_relayd
188 stop_lttng_sessiond
189 reset_bw_limit
190 done
191 }
This page took 0.035947 seconds and 6 git commands to generate.